<template>
<b-card bg-variant="light"  class="mb-3">
    <center><h3 class="font_size_18 uppercase text-first mb-4">Informations d'authentification</h3></center>
    <b-row class="mb-3">
        <b-col cols="4">
                <label>Type</label>
        </b-col>
        <b-col cols="8">
                <b-select  value-field="item" text-field="name" v-model="authenticationInfos.type" :options="authTypeList">
                </b-select>
        </b-col>
    </b-row>

  <FormTextInput v-bind:label="'Login'" v-model="authenticationInfos.login"
    @input="onInfosChange()"/>
  <FormTextInput v-bind:label="'Password'"
  @input="onInfosChange()" v-model="authenticationInfos.password"/>

  <b-row>
    <b-col  >
      <b-form-checkbox
        v-model="authenticationInfos.store" switch @change="onStoreChange()">
        Enregister les infos sur le navigateur
      </b-form-checkbox>
    </b-col>
  </b-row>
</b-card>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import AuthenticationInfos from '@/models/map-context/AuthenticationInfos';
import FormTextInput from '@/components/shared/FormTextInput.vue';
import { EventBus, EVENTS } from '@/services/EventBus';
import Component from 'vue-class-component';
import BaseComponent from '../BaseComponent';

@Component({
  props: {
    authenticationInfos: AuthenticationInfos,
    url: String,
  },
  components: {
    FormTextInput,
  },
})
export default class AuthenticationInfoPanel extends BaseComponent {
  authenticationInfos!:AuthenticationInfos;

  url!:string;

  authTypeList=[
    { item: 'none', name: 'Aucune' },
    { item: 'basic', name: 'Simple (Basic Auth)' }];

  mounted() {
    console.log(this.authenticationInfos);
  }

  onInfosChange() {
    if (this.authenticationInfos.store) {
      this.contextService.addAuthInfo(this.url, this.authenticationInfos);
    }
  }

  onStoreChange() {
    console.log(this.authenticationInfos.store);
    if (this.authenticationInfos.store) {
      this.contextService.addAuthInfo(this.url, this.authenticationInfos);
    } else {
      this.contextService.removeAuthInfo(this.url);
    }
  }
}
</script>

<style scoped lang="less">
.authentication{
  margin:5px;
  padding:5px;
  border-radius: 2px;
  box-shadow: 0 1px 3px rgba(0,0,0,0.12), 0 1px 2px rgba(0,0,0,0.24);
  transition: all 0.3s cubic-bezier(.25,.8,.25,1);
}
</style>
